addpath('../yael/matlab')


basename = '../example_data/groupFungus_k64_nclass134_nex50'

% load train data
Xtrain = fvecs_read([basename '_Xtrain.fvecs']);
Ltrain = ivecs_read([basename '_Ltrain.ivecs']);

% load test data
Xtest = fvecs_read([basename '_Xtest.fvecs']);
Ltest = ivecs_read([basename '_Ltest.ivecs']);


% random permutation of train 
[d, n] = size(Xtrain)
perm = randperm(n); 

Xtrain = Xtrain(:, perm); 
Ltrain = Ltrain(perm);

n_epoch = 60; 


% example with default parameters of OVR

[W,stats] = jsgd_train(single(Xtrain), int32(Ltrain), ...
                       'valid', single(Xtest), ...
                       'valid_labels', int32(Ltest), ...
                       'verbose', 2, ...
                       'eval_freq', n_epoch, ...
                       'n_epoch', n_epoch, ...
                       'n_thread', 1);

% with other algorithms below...
if 0

  
[W,stats_mul] = jsgd_train(single(Xtrain), int32(Ltrain), ...
                           'algo', 'mul', ...
                           'valid', single(Xtest), ...
                           'valid_labels', int32(Ltest), ...                    
                           'lambda', 1e-5,...
                           'bias_term', 1,...
                           'eta0', 0.01,...                       
                           'verbose', 2, ...
                           'eval_freq', n_epoch, ...
                           'n_epoch', n_epoch);


[W,stats_rnk] = jsgd_train(single(Xtrain), int32(Ltrain), ...
                           'algo', 'rnk', ...
                           'valid', single(Xtest), ...
                           'valid_labels', int32(Ltest), ...                    
                           'lambda', 1e-5,...
                           'bias_term', 0.1,...
                           'eta0', 0.01,...                       
                           'verbose', 2, ...
                           'eval_freq', n_epoch, ...
                           'n_epoch', n_epoch);



[W,stats_war] = jsgd_train(single(Xtrain), int32(Ltrain), ...
                           'algo', 'war', ...
                           'valid', single(Xtest), ...
                           'valid_labels', int32(Ltest), ...                    
                           'lambda', 1e-6,...
                           'bias_term', 1,...
                           'eta0', 0.01,...                       
                           'verbose', 2, ...
                           'eval_freq', n_epoch, ...
                           'n_epoch', n_epoch);

end

ntest = size(Xtest, 2)
[scores, found_labels]  = max(W' * [Xtest ; ones(1, ntest)]);
accuracy = sum(found_labels == Ltest) / ntest

